// This automaton represents LDV Tools specification 132_1a.

OBSERVER AUTOMATON AUTOMATON_132_1a
INITIAL STATE Init;

STATE USEALL Init :
  MATCH ENTRY -> ENCODE {int count = 0;} GOTO Init;

  MATCH CALL {ldv_usb_get_dev($?)} -> ENCODE {count=count+1;} GOTO Inc;
  MATCH CALL {ldv_usb_put_dev($?)} -> ERROR("put without get");

STATE USEALL Inc :
  MATCH CALL {ldv_usb_get_dev($?)} -> ENCODE {count=count+1;} GOTO Inc;

  // An ENCODE is performed after applying the ASSUME!
  MATCH CALL {ldv_usb_put_dev($?)} -> ASSUME {count >  1} ENCODE {count=count-1;} GOTO Inc;
  MATCH CALL {ldv_usb_put_dev($?)} -> ASSUME {count == 1} ENCODE {count=count-1;} GOTO Init;

  MATCH CALL {ldv_check_return_value_probe($1)} -> ASSUME {((int)$1) == 0} GOTO Inc;
  MATCH CALL {ldv_check_return_value_probe($1)} -> ASSUME {((int)$1) != 0} ERROR("get without put on failed probe");

  //MATCH EXIT -> ERROR("get without put");
  MATCH CALL {ldv_check_final_state($?)} -> ERROR("get without put");

END AUTOMATON
